
def ma_fct(x: int):
    if x > 5:
        return 
    print(x)
    ma_fct(x + 1)
    print(x)
    
ma_fct(0)

T = list["T"] | int 

def applatir(L : T) -> list[int]:
    if isinstance(L, int):
        return [L]
    resultat = []
    for element in L:
        resultat.extend(applatir(element))
    return resultat

#### Fonctionelle #### 


def f() -> int:
    return 1

x = f

def f() -> int:
    return 2

print(x())


def g():
    return g

print(g()()()()()()()()()()()()())


def eval(f, x, y):
    return f(x, y)

def add(x, y):
    return x + y

print(eval(add, 3, 5)) # print(add(3, 5))


def print_arg_eval(f, x, y):
    print(x, y)
    return f(x, y)

print_arg_eval(add, 3, 5)

## MAP ## 
from typing import Callable, Iterable

def map(f: Callable, L: Iterable) -> list:
    resultat = []
    for x in L:
        resultat.append(f(x))
    return resultat

def applatir2(L : T) -> list[int]:
    if isinstance(L, int):
        return [L]
    return map(applatir, L)


def filter(fct: Callable, L: list) -> list:
    resultat = []
    for x in L:
        if fct(x):
            resultat.append(x)
    return resultat

